var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import Webfont from 'webfontloader';

var getFamilies = function getFamilies(source, families) {
  return source === 'typekit' ? { id: families.join(';'), api: '//use.edgefonts.net' } : { families: families };
};

var getUrls = function getUrls(source, urls) {
  return source === 'custom' ? { urls: urls } : {};
};

var getCharacterSubsetting = function getCharacterSubsetting(source, text) {
  return source === 'google' && text ? { text: text } : {};
};

var WebFontComponent = function (_Component) {
  _inherits(WebFontComponent, _Component);

  function WebFontComponent() {
    var _temp, _this, _ret;

    _classCallCheck(this, WebFontComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: false,
      active: false,
      inactive: false
    }, _this.loadFonts = function (_ref) {
      var _webfontOptions;

      var source = _ref.source;
      var families = _ref.families;
      var urls = _ref.urls;
      var text = _ref.text;
      var _ref$classes = _ref.classes;
      var classes = _ref$classes === undefined ? true : _ref$classes;
      var _ref$events = _ref.events;
      var events = _ref$events === undefined ? true : _ref$events;
      var _ref$timeout = _ref.timeout;
      var timeout = _ref$timeout === undefined ? 3000 : _ref$timeout;

      var webfontOptions = (_webfontOptions = {}, _webfontOptions[source] = _extends({}, getFamilies(source, families), getUrls(source, urls), getCharacterSubsetting(source, text)), _webfontOptions.classes = classes, _webfontOptions.events = events, _webfontOptions.timeout = timeout, _webfontOptions.loading = function loading() {
        console.log('loading');
        return !_this.willUnmount ? _this.setState({ loading: true, active: false, inactive: false }) : undefined;
      }, _webfontOptions.active = function active() {
        return !_this.willUnmount ? _this.setState({ loading: false, active: true, inactive: false }) : undefined;
      }, _webfontOptions.inactive = function inactive() {
        return !_this.willUnmount ? _this.setState({ loading: false, active: false, inactive: true }) : undefined;
      }, _webfontOptions);

      console.log(webfontOptions);

      Webfont.load(webfontOptions);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  WebFontComponent.prototype.componentDidMount = function componentDidMount() {
    this.loadFonts(this.props);
  };

  WebFontComponent.prototype.componentWillUnmount = function componentWillUnmount() {
    this.willUnmount = true;
  };

  WebFontComponent.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    this.loadFonts(nextProps);
  };

  WebFontComponent.prototype.render = function render() {
    return this.props.children(_extends({}, this.state)) || null;
  };

  return WebFontComponent;
}(Component);

export default WebFontComponent;